/*
 *  Copyright 2012-15 ARM Limited and Contributors.
 *  All rights reserved.
 *
 *  Redistribution and use in source and binary forms, with or without
 *  modification, are permitted provided that the following conditions are met:
 *    * Redistributions of source code must retain the above copyright
 *      notice, this list of conditions and the following disclaimer.
 *    * Redistributions in binary form must reproduce the above copyright
 *      notice, this list of conditions and the following disclaimer in the
 *      documentation and/or other materials provided with the distribution.
 *    * Neither the name of ARM Limited nor the
 *      names of its contributors may be used to endorse or promote products
 *      derived from this software without specific prior written permission.
 *
 *  THIS SOFTWARE IS PROVIDED BY ARM LIMITED AND CONTRIBUTORS "AS IS" AND
 *  ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 *  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 *  DISCLAIMED. IN NO EVENT SHALL ARM LIMITED AND CONTRIBUTORS BE LIABLE FOR ANY
 *  DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 *  (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 *  LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 *  ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 *  (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 *  SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

/*
 * NE10 Library : test_main.c
 */

#include "seatest.h"

void test_fixture_fft_c2c_1d_float32 (void);
void test_fixture_fft_c2c_1d_int32 (void);
void test_fixture_fft_c2c_1d_int16 (void);
void test_fixture_fft_r2c_1d_float32 (void);
void test_fixture_fft_r2c_1d_int32 (void);
void test_fixture_fft_r2c_1d_int16 (void);
void test_fixture_fir (void);
void test_fixture_fir_decimate (void);
void test_fixture_fir_interpolate (void);
void test_fixture_fir_lattice (void);
void test_fixture_fir_sparse (void);
void test_fixture_iir_lattice (void);

void all_tests (void)
{
    test_fixture_fft_c2c_1d_float32();
    test_fixture_fft_r2c_1d_float32();
    test_fixture_fft_c2c_1d_int32();
    test_fixture_fft_r2c_1d_int32();
    test_fixture_fft_c2c_1d_int16();
    test_fixture_fft_r2c_1d_int16();
    test_fixture_fir();
    test_fixture_fir_decimate();
    test_fixture_fir_interpolate();
    test_fixture_fir_lattice();
    test_fixture_fir_sparse();
    test_fixture_iir_lattice();
}


void my_suite_setup (void)
{
    //printf("I'm done before every single test in the suite\r\n");
}

void my_suite_teardown (void)
{
    //printf("I'm done after every single test in the suite\r\n");
}

int main (ne10_int32_t argc, char** argv)
{
    suite_setup (my_suite_setup);
    suite_teardown (my_suite_teardown);
    return !run_tests (all_tests);
}
